using UnityEngine;
using System.Collections;

namespace Amaimon {
    ///////////////////////////////////////////////////
    // A builder for vanilla sex
    ///////////////////////////////////////////////////

    class PenetrationStateBuilder {
        public string activeParty = "";
        public string movementPlane = "";
        public string orifice = "";
        public string poseName = "";
                
        public AActor m;
        public AActor f;

        public Vector3 root;

        public static PenetrationStateBuilder begin(AActor mm, AActor ff, Vector3 r) {
            var sb = new PenetrationStateBuilder();
            sb.m = mm;
            sb.f = ff;
            sb.root = r;
            return sb;
        } 

        public PenetrationStateBuilder setActiveParty(string a) {
            activeParty = a;
            return this;
        }

        public PenetrationStateBuilder setOrifice(string o) {
            orifice = o;
            return this;
        }

        public PenetrationStateBuilder setPlane(string p) {
            movementPlane = p;
            return this;
        }

        public PenetrationStateBuilder setPose(string p) {
            poseName = p;
            return this;
        }

	    //public static T FindWithinSamePlugin<T>(MVRScript self) where T : MVRScript
        public SceneState build() {
            if(orifice == AActor.ORIFICE_MOUTH && activeParty == SceneState.PARTY_FEMALE) {
                return new BlowjobStateFM(f, m, root, poseName);
            }
            else if((orifice == AActor.ORIFICE_LEFT_HAND || orifice == AActor.ORIFICE_RIGHT_HAND) && activeParty == SceneState.PARTY_FEMALE) {
                return new HandjobStateFM(f, m, root, poseName, orifice);
            }
            else {
                return new FuckStateMF(m, f, root, poseName, orifice, movementPlane, activeParty);
            }
        }
    }

    ///////////////////////////////////////////////////
    // An scene state with some basic methods
    ///////////////////////////////////////////////////

    public class SceneState : BaseState {
        public static string PARTY_MALE = "m";
        public static string PARTY_FEMALE = "f";
        public static string PARTY_NONE = "";

        public Vector3 root;
        public string orifice;
        public SceneState(AActor m, AActor f, Vector3 r) : base(m, f) {
            root = r;
        }

        override public BaseState changeIf(Scene s) { return null; }
        override public void onRun(Scene s) {}
        override public void onEnter(Scene s) {}
        override public void onExit(Scene s) {}

        public bool femaleMouthWithinPenis(float dist) {
            return male.getDistance("penisTip", female, "MouthTrigger") < dist;
        }

        public bool leftFemaleHandWithinPenis(float dist) {
            return male.getDistance("penisTip", female, "lHand") < dist;
        }

        public bool rightFemaleHandWithinPenis(float dist) {
            return male.getDistance("penisTip", female, "lHand") < dist;
        }

        public bool femaleLabiaWithinPenis(float dist) {
            return male.getDistance("penisTip", female, "LabiaTrigger") < dist;
        }
        public void poseVamasutra(string poseName, Vector3 root) {
            if(poseName == "")
                return;

            male.setCollision(false);
            female.setCollision(false);

            string mPosePath = $"Custom/Atom/Person/Pose/Together/Paired/Preset_{poseName}_M.vap";
            string fPosePath = $"Custom/Atom/Person/Pose/Together/Paired/Preset_{poseName}_F.vap";
            male.loadPose(mPosePath);
            female.loadPose(fPosePath);

            var maleDest = new Vector3(-0.2f,0.0f,0.0f) + root;
            var femaleDest =  new Vector3(0.2f,0.0f,0.0f) + root;

            male.position = maleDest;
            male.rotation = new Quaternion();

            female.position = femaleDest;
            female.rotation = new Quaternion();

            // must be enabled late to allow move!
            StoryPlugin.singleton?.StartCoroutine(reenableCollisions(maleDest, femaleDest));
        }

        IEnumerator reenableCollisions(Vector3 maleDest, Vector3 femaleDest) {
            float maleDist;
            float femaleDist;

            bool areClose = false;

            var femalePelvis = female.getRigidBody("pelvis").transform;
            var malePelvis = female.getRigidBody("pelvis").transform;

            while (!areClose)
            {
                maleDist =  Vector3.Distance(malePelvis.position, maleDest);
                femaleDist =  Vector3.Distance(femalePelvis.position, femaleDest);

                //Log.d($"distances: {maleDist} and {femaleDist}");

                areClose = (maleDist < 1.5f && femaleDist < 1.5f);
                if(!areClose)
                    yield return new WaitForSeconds(0.1f);                 
            }

            Log.d($"Enabled collisitons when dist: {maleDist} and {femaleDist}");

            male.setCollision(true);
            female.setCollision(true);
        }

        public IEnumerator bumpCollisions(AActor a) {
            yield return new WaitForSeconds(1f);
            a.setCollision(false);
            yield return new WaitForSeconds(0.5f);
            a.setCollision(true);

        }

        public IEnumerator setupPenetration() {
            //Log.d($"switching to {orifice}");

            male.diviningRodPl.isEnabled = false;

            male.diviningRodPl.setVaginaEnabled(false);
            male.diviningRodPl.setMouthEnabled(false);
            male.diviningRodPl.setAnusEnabled(false);
            male.diviningRodPl.setLeftHandEnabled(false);
            male.diviningRodPl.setRightHandEnabled(false);
            male.diviningRodPl.setFemaleEnabled(true);

            if(orifice == AActor.ORIFICE_VAGINA)
                male.diviningRodPl.setVaginaEnabled(true);
            else if(orifice == AActor.ORIFICE_ANUS)
                male.diviningRodPl.setAnusEnabled(true);
            else if(orifice == AActor.ORIFICE_MOUTH)
                male.diviningRodPl.setMouthEnabled(true);
            else if(orifice == AActor.ORIFICE_RIGHT_HAND)
                male.diviningRodPl.setRightHandEnabled(true);
            else if(orifice == AActor.ORIFICE_LEFT_HAND)
                male.diviningRodPl.setLeftHandEnabled(true);

            male.diviningRodPl.isEnabled = true;
            // reszta - default
            // może tutaj zrobić thrustera na pełnym wyjęciu

            //Log.d($"Set penertation for {orifice}");

            yield return new WaitForSeconds(1f);
        }
    }

    ///////////////////////////////////////////////////
    // An idle state that can change to sex state with proximity triggers
    ///////////////////////////////////////////////////

    public class ActiveIdleState : SceneState {
        public ActiveIdleState(AActor m, AActor f, Vector3 root) : base(m, f, root) {
            orifice = "";
        }

        override public void onEnter(Scene s) {
            StoryPlugin.singleton?.StartCoroutine(setupPenetration());
            male.sexThrusterPl.setActive(false);            
        }

        override public BaseState changeIf(Scene s) {
            if(femaleLabiaWithinPenis(0.15f)) {
                return new FuckStateMF(male, female, root, "", AActor.ORIFICE_VAGINA, "vert", PARTY_FEMALE);
            }
            else if(femaleMouthWithinPenis(0.30f)) {
                return new BlowjobStateFM(female, male, root, "");
            }
            else if(leftFemaleHandWithinPenis(0.15f)) {
                return new HandjobStateFM(female, male, root, "", AActor.ORIFICE_LEFT_HAND);
            }
            else if(rightFemaleHandWithinPenis(0.15f)) {
                return new HandjobStateFM(female, male, root, "", AActor.ORIFICE_RIGHT_HAND);
            }

            return null;       
        }
    }

    ///////////////////////////////////////////////////
    // A state for general penetration
    ///////////////////////////////////////////////////

    public class FuckStateMF : SceneState {
        private string movementPlane = "";
        private string activeParty = "";
        private string poseName = "";

        public FuckStateMF(AActor m, AActor f, Vector3 root, string pn, string ori, string plane, string active) : base(m, f, root) {
            poseName = pn;
            orifice = ori;
            //Log.d($"Orifice in FuckState constr:{orifice}");
            movementPlane = plane;
            activeParty = active;
        }

        override public void onEnter(Scene s) {
            StoryPlugin.singleton?.StartCoroutine(setupPenetration());
            poseVamasutra(poseName, root);

            male.sexThrusterPl.setActive(false);
            male.sexThrusterPl.isEnabled = false;
            male.sexThrusterPl.setMale(male);
            male.sexThrusterPl.setFemale(female);
            male.sexThrusterPl.setCycleDuration(0.62f);
            male.sexThrusterPl.setCycleDurationIn(0.26f);
            male.sexThrusterPl.setCycleDurationRandom(0.52f);
            male.sexThrusterPl.setCycleUpdateFreq(14f);
            male.sexThrusterPl.setEaseIn("Cubic In");
            male.sexThrusterPl.setEaseOut("Linear");
            male.sexThrusterPl.setPenisAngleUpDown(0f);

            male.sexThrusterPl.setEnableFemaleThrust(false);
            male.sexThrusterPl.setEnableMaleThrust(false);
            if(activeParty == PARTY_MALE) {
                //Log.d("Setting thruster for male");
                male.sexThrusterPl.setEnableMaleThrust(true);
                // horiz
                male.sexThrusterPl.setMalePositionIn(-0.40f);
                male.sexThrusterPl.setMalePositionOut(-3.95f);

            }
            else if(activeParty == PARTY_FEMALE) {
                //Log.d("Setting thruster for female");
                male.sexThrusterPl.setEnableFemaleThrust(true);
                // horiz
                male.sexThrusterPl.setFemalePositionIn(-0.08f);
                male.sexThrusterPl.setFemalePositionOut(-3.75f);
            }
            
            male.sexThrusterPl.isEnabled = true;
            male.sexThrusterPl.setActive(true);
        }

        override public void onExit(Scene s) {
            male.sexThrusterPl.setActive(false);
        }

        override public BaseState changeIf(Scene s) {
            float dist = 0;

            if(isSettled &&
                (orifice == AActor.ORIFICE_MOUTH && !femaleMouthWithinPenis(0.7f) ||
                orifice == AActor.ORIFICE_VAGINA && !femaleLabiaWithinPenis(0.7f))
            )
            {
                female.say("Put it back in, PLEASE!");
                return new ActiveIdleState(male, female, root);
            }
            else
                return null;       
        }
    }

    ///////////////////////////////////////////////////
    // A state for left-hand-job
    ///////////////////////////////////////////////////

    public class HandjobStateFM : Amaimon.SceneState {
        private string poseName = "";

        public HandjobStateFM(AActor f, AActor m, Vector3 root, string pn, string o) : base(m, f, root) {
            orifice = o;
            poseName = pn;
        }

        override public void onEnter(Scene s) {
            StoryPlugin.singleton?.StartCoroutine(setupPenetration());
            poseVamasutra(poseName, root);

            if(orifice == AActor.ORIFICE_LEFT_HAND)
                female.handjobPl.setTarget(male, ClockwiseSilverHJPlugin.LEFT_HAND);
            if(orifice == AActor.ORIFICE_RIGHT_HAND)
                female.handjobPl.setTarget(male, ClockwiseSilverHJPlugin.RIGHT_HAND);

            female.handjobPl.isEnabled = true;
            female.handjobPl.setActive(true);
        }

        override public void onExit(Scene s) {
            female.handjobPl.StopHJ.call();
            female.handjobPl.setActive(false);
            female.handjobPl.isEnabled = false;
        }

        override public BaseState changeIf(Scene s) {
            float dist = 1000;


            if(
                isSettled &&
                (orifice == AActor.ORIFICE_LEFT_HAND && !leftFemaleHandWithinPenis(0.3f) ||
                orifice == AActor.ORIFICE_RIGHT_HAND && !rightFemaleHandWithinPenis(0.3f))
            )
            {
                female.say("Give it back, NOW!");
                return new ActiveIdleState(male, female, root);
            }
            else if(elapsedSeconds()>20f && femaleMouthWithinPenis(0.3f)) {
                return new BlowjobStateFM(female, male, root, "");
            }

            return null;       
        }
    }

    ///////////////////////////////////////////////////
    // A state for blowjob
    ///////////////////////////////////////////////////

    public class BlowjobStateFM : Amaimon.SceneState {
        private string poseName = "";

        public BlowjobStateFM(AActor f, AActor m, Vector3 root, string pn) : base(m, f, root) {
            poseName = pn;
        }

        override public void onEnter(Scene s) {
            orifice = AActor.ORIFICE_MOUTH;
            StoryPlugin.singleton?.StartCoroutine(setupPenetration());
            poseVamasutra(poseName, root);

            female.blowjobPl.setTarget(male);
            female.blowjobPl.isEnabled = true;
            female.blowjobPl.setHeadFwdBkwd(0.15f);
            female.blowjobPl.setHeadSideSide(0.07f);
            female.blowjobPl.setHeadAngleXMin(-84f);
            female.blowjobPl.setHeadAngleXMax(-3f);
            female.blowjobPl.setActive(true);
            StoryPlugin.singleton?.StartCoroutine(bumpCollisions(female));

        }

        override public void onExit(Scene s) {
            female.blowjobPl.setActive(false);
            female.blowjobPl.isEnabled = false;
            Log.d("Blowjob diabled");
        }

        override public BaseState changeIf(Scene s) {
            if(isSettled && !femaleMouthWithinPenis(0.30f)) {
                female.say("Hey! I was sucking that!");
                return new ActiveIdleState(male, female, root);
            }
            else if(elapsedSeconds()>20f) {
                if(leftFemaleHandWithinPenis(0.15f)) {
                    return new HandjobStateFM(female, male, root, "", AActor.ORIFICE_LEFT_HAND);
                }
                else if(rightFemaleHandWithinPenis(0.15f)) {
                    return new HandjobStateFM(female, male, root, "", AActor.ORIFICE_RIGHT_HAND);
                }
            }

            return null;       
        }
    }

    ///////////////////////////////////////////////////
    // Girl blowjob scene
    ///////////////////////////////////////////////////
    // ActiveGirlBlowjobSceneMF: 69, bed head, blowjob, blowjob2, blowjob3, blowjob4, boss chair bj, cinema bj, doctor bj, kneeling bj, standing 69

    ///////////////////////////////////////////////////
    // Girl riding up/down
    ///////////////////////////////////////////////////
    // VerticallyActiveGirlSceneMF: acrobat, asian cowgirl, bent spoon, betty rocker, bouncing spoon, corner cowgirl, cowgirl, crab, irish garden, jellyfish, lap dance, lotus, lunge, man missionary
    // perarly gates, piston, quickie, reverse cowgirl, riding2, screw, seesaw, side ride, sitting, sitting2, sofa, squatting, squatting2, stand and carry, sybian
    // tug of love

    ///////////////////////////////////////////////////
    // Girl sideways
    ///////////////////////////////////////////////////
    // F przód/tył: amazon, ballerina, blooming orchid, intersection, juggerhead, octopuss, spooning, turtle,
 
    ///////////////////////////////////////////////////
    // Boy fucking sideways
    ///////////////////////////////////////////////////
    // HorizontallyActiveBoySceneMF: doggy1, 8 G Spot, anal spooning, basset hound, bookends, bridge, butterfly, criss cross, doggy, down stroke, face fuck bj, face to face, fire hydrant
    // italian chandelier, kneeling, launch pad, leapfrog, leg glider, legs over shoulder, lie back, life art, plumber bj, pretzel, piston, right angle, sandwich,
    // scissor, stairs, standing missionary, teaspooning, washing machine, wheelbarrow,

    ///////////////////////////////////////////////////
    // Boy fucking up/down
    ///////////////////////////////////////////////////
    // M góra/dół: coital alignment, drill, missionary hanging, missionary, spread legs, standing, standing3, viennese oyster
    
    // HJ: bed handjob, handjob1, 

}