using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using UnityEngine.XR;
using UnityEngine.Windows.Speech;

using SimpleJSON;

namespace Amaimon {
        ///////////////////////////////////////////////////
    // Divining Rod
    ///////////////////////////////////////////////////
    public class DiviningRodPlugin : APlugin {
        public DiviningRodPlugin(AActor actor) : base(actor, "DiviningRod") { }

        override public void init() {
            MouthEnabled = new BoolProperty(this,"Mouth Enabled");
            VaginaEnabled = new BoolProperty(this,"Vagina Enabled");
            AnusEnabled = new BoolProperty(this,"Anus Enabled");
            RightHandEnabled = new BoolProperty(this,"Right Hand Enabled");
            LeftHandEnabled = new BoolProperty(this,"Left Hand Enabled");
            FemaleEnabled = new BoolProperty(this,"Female Enabled");
            MaleEnabled = new BoolProperty(this,"Male Enabled");
            customTargetAtom = new StringChooserProperty(this,"customTargetAtom");
            customTarget = new StringChooserProperty(this,"customTarget");
            MinTargetDistancecm = new FloatProperty(this,"Min Target Distance [cm]");
            MinRetargetDistancecm = new FloatProperty(this,"Min Retarget Distance [cm]");
            AdaptationRates = new FloatProperty(this,"Adaptation Rate [%/s]");
            DynamicAdaptationRate = new BoolProperty(this,"Dynamic Adaptation Rate");
            AvoidPopOut = new BoolProperty(this,"Avoid Pop Out");
            PopOutDetectionThreshold = new FloatProperty(this,"Pop Out Detection Threshold [°]");
            VerifyWithTrigger = new BoolProperty(this,"Verify With Trigger");
            InstantPopBack = new BoolProperty(this,"Instant Pop Back");
            ForceTipToTarget = new FloatProperty(this,"Force Tip To Target");
            MouthOffsetXcm = new FloatProperty(this,"Mouth Offset X [cm]");
            MouthOffsetYcm = new FloatProperty(this,"Mouth Offset Y [cm]");
            MouthOffsetZcm = new FloatProperty(this,"Mouth Offset Z [cm]");
            VaginaOffsetXcm = new FloatProperty(this,"Vagina Offset X [cm]");
            VaginaOffsetYcm = new FloatProperty(this,"Vagina Offset Y [cm]");
            VaginaOffsetZcm = new FloatProperty(this,"Vagina Offset Z [cm]");
            AnusOffsetXcm = new FloatProperty(this,"Anus Offset X [cm]");
            AnusOffsetYcm = new FloatProperty(this,"Anus Offset Y [cm]");
            AnusOffsetZcm = new FloatProperty(this,"Anus Offset Z [cm]");
            HandOffsetXcm = new FloatProperty(this,"Hand Offset X [cm]");
            HandOffsetYcm = new FloatProperty(this,"Hand Offset Y [cm]");
            HandOffsetZcm = new FloatProperty(this,"Hand Offset Z [cm]");
            CustomTargetOffsetXcm = new FloatProperty(this,"Custom Target Offset X [cm]");
            CustomTargetOffsetYcm = new FloatProperty(this,"Custom Target Offset Y [cm]");
            CustomTargetOffsetZcm = new FloatProperty(this,"Custom Target Offset Z [cm]");
        }
        
        private BoolProperty MouthEnabled;

        public void setMouthEnabled(bool a) {
            MouthEnabled.set(a);
        }
        
        public bool getMouthEnabled() {
            return MouthEnabled.get();
        }

        
        private BoolProperty VaginaEnabled;

        public void setVaginaEnabled(bool a) {
            VaginaEnabled.set(a);
        }
        
        public bool getVaginaEnabled() {
            return VaginaEnabled.get();
        }

        
        private BoolProperty AnusEnabled;

        public void setAnusEnabled(bool a) {
            AnusEnabled.set(a);
        }
        
        public bool getAnusEnabled() {
            return AnusEnabled.get();
        }

        
        private BoolProperty RightHandEnabled;

        public void setRightHandEnabled(bool a) {
            RightHandEnabled.set(a);
        }
        
        public bool getRightHandEnabled() {
            return RightHandEnabled.get();
        }

        
        private BoolProperty LeftHandEnabled;

        public void setLeftHandEnabled(bool a) {
            LeftHandEnabled.set(a);
        }
        
        public bool getLeftHandEnabled() {
            return LeftHandEnabled.get();
        }

        
        private BoolProperty FemaleEnabled;

        public void setFemaleEnabled(bool a) {
            FemaleEnabled.set(a);
        }
        
        public bool getFemaleEnabled() {
            return FemaleEnabled.get();
        }

        
        private BoolProperty MaleEnabled;

        public void setMaleEnabled(bool a) {
            MaleEnabled.set(a);
        }
        
        public bool getMaleEnabled() {
            return MaleEnabled.get();
        }

        
        private StringChooserProperty customTargetAtom;

        public void setcustomTargetAtom(string a) {
            customTargetAtom.set(a);
        }
        
        public string getcustomTargetAtom() {
            return customTargetAtom.get();
        }

        
        private StringChooserProperty customTarget;

        public void setcustomTarget(string a) {
            customTarget.set(a);
        }
        
        public string getcustomTarget() {
            return customTarget.get();
        }

        
        private FloatProperty MinTargetDistancecm;

        public void setMinTargetDistancecm(float a) {
            MinTargetDistancecm.set(a);
        }
        
        public float getMinTargetDistancecm() {
            return MinTargetDistancecm.get();
        }

        
        private FloatProperty MinRetargetDistancecm;

        public void setMinRetargetDistancecm(float a) {
            MinRetargetDistancecm.set(a);
        }
        
        public float getMinRetargetDistancecm() {
            return MinRetargetDistancecm.get();
        }

        
        private FloatProperty AdaptationRates;

        public void setAdaptationRates(float a) {
            AdaptationRates.set(a);
        }
        
        public float getAdaptationRates() {
            return AdaptationRates.get();
        }

        
        private BoolProperty DynamicAdaptationRate;

        public void setDynamicAdaptationRate(bool a) {
            DynamicAdaptationRate.set(a);
        }
        
        public bool getDynamicAdaptationRate() {
            return DynamicAdaptationRate.get();
        }

        
        private BoolProperty AvoidPopOut;

        public void setAvoidPopOut(bool a) {
            AvoidPopOut.set(a);
        }
        
        public bool getAvoidPopOut() {
            return AvoidPopOut.get();
        }

        
        private FloatProperty PopOutDetectionThreshold;

        public void setPopOutDetectionThreshold(float a) {
            PopOutDetectionThreshold.set(a);
        }
        
        public float getPopOutDetectionThreshold() {
            return PopOutDetectionThreshold.get();
        }

        
        private BoolProperty VerifyWithTrigger;

        public void setVerifyWithTrigger(bool a) {
            VerifyWithTrigger.set(a);
        }
        
        public bool getVerifyWithTrigger() {
            return VerifyWithTrigger.get();
        }

        
        private BoolProperty InstantPopBack;

        public void setInstantPopBack(bool a) {
            InstantPopBack.set(a);
        }
        
        public bool getInstantPopBack() {
            return InstantPopBack.get();
        }

        
        private FloatProperty ForceTipToTarget;

        public void setForceTipToTarget(float a) {
            ForceTipToTarget.set(a);
        }
        
        public float getForceTipToTarget() {
            return ForceTipToTarget.get();
        }

        
        private FloatProperty MouthOffsetXcm;

        public void setMouthOffsetXcm(float a) {
            MouthOffsetXcm.set(a);
        }
        
        public float getMouthOffsetXcm() {
            return MouthOffsetXcm.get();
        }

        
        private FloatProperty MouthOffsetYcm;

        public void setMouthOffsetYcm(float a) {
            MouthOffsetYcm.set(a);
        }
        
        public float getMouthOffsetYcm() {
            return MouthOffsetYcm.get();
        }

        
        private FloatProperty MouthOffsetZcm;

        public void setMouthOffsetZcm(float a) {
            MouthOffsetZcm.set(a);
        }
        
        public float getMouthOffsetZcm() {
            return MouthOffsetZcm.get();
        }

        
        private FloatProperty VaginaOffsetXcm;

        public void setVaginaOffsetXcm(float a) {
            VaginaOffsetXcm.set(a);
        }
        
        public float getVaginaOffsetXcm() {
            return VaginaOffsetXcm.get();
        }

        
        private FloatProperty VaginaOffsetYcm;

        public void setVaginaOffsetYcm(float a) {
            VaginaOffsetYcm.set(a);
        }
        
        public float getVaginaOffsetYcm() {
            return VaginaOffsetYcm.get();
        }

        
        private FloatProperty VaginaOffsetZcm;

        public void setVaginaOffsetZcm(float a) {
            VaginaOffsetZcm.set(a);
        }
        
        public float getVaginaOffsetZcm() {
            return VaginaOffsetZcm.get();
        }

        
        private FloatProperty AnusOffsetXcm;

        public void setAnusOffsetXcm(float a) {
            AnusOffsetXcm.set(a);
        }
        
        public float getAnusOffsetXcm() {
            return AnusOffsetXcm.get();
        }

        
        private FloatProperty AnusOffsetYcm;

        public void setAnusOffsetYcm(float a) {
            AnusOffsetYcm.set(a);
        }
        
        public float getAnusOffsetYcm() {
            return AnusOffsetYcm.get();
        }

        
        private FloatProperty AnusOffsetZcm;

        public void setAnusOffsetZcm(float a) {
            AnusOffsetZcm.set(a);
        }
        
        public float getAnusOffsetZcm() {
            return AnusOffsetZcm.get();
        }

        
        private FloatProperty HandOffsetXcm;

        public void setHandOffsetXcm(float a) {
            HandOffsetXcm.set(a);
        }
        
        public float getHandOffsetXcm() {
            return HandOffsetXcm.get();
        }

        
        private FloatProperty HandOffsetYcm;

        public void setHandOffsetYcm(float a) {
            HandOffsetYcm.set(a);
        }
        
        public float getHandOffsetYcm() {
            return HandOffsetYcm.get();
        }

        
        private FloatProperty HandOffsetZcm;

        public void setHandOffsetZcm(float a) {
            HandOffsetZcm.set(a);
        }
        
        public float getHandOffsetZcm() {
            return HandOffsetZcm.get();
        }

        
        private FloatProperty CustomTargetOffsetXcm;

        public void setCustomTargetOffsetXcm(float a) {
            CustomTargetOffsetXcm.set(a);
        }
        
        public float getCustomTargetOffsetXcm() {
            return CustomTargetOffsetXcm.get();
        }

        
        private FloatProperty CustomTargetOffsetYcm;

        public void setCustomTargetOffsetYcm(float a) {
            CustomTargetOffsetYcm.set(a);
        }
        
        public float getCustomTargetOffsetYcm() {
            return CustomTargetOffsetYcm.get();
        }

        
        private FloatProperty CustomTargetOffsetZcm;

        public void setCustomTargetOffsetZcm(float a) {
            CustomTargetOffsetZcm.set(a);
        }
        
        public float getCustomTargetOffsetZcm() {
            return CustomTargetOffsetZcm.get();
        }


    }

}