using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;

using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using UnityEngine.XR;

using SimpleJSON;

namespace Amaimon {
    public partial class AActor : AAtom {
        
        public float getScaredRelaxedInterval() {
            // calculate shorter intervals for scared. longer for relaxed

            if(scaredRelaxed < 0) {
                return UnityEngine.Random.Range(-0.25f/scaredRelaxed, -1f/scaredRelaxed);
            }
            else {
                return  UnityEngine.Random.Range(2+scaredRelaxed*2f, 4+scaredRelaxed*2f);
            }
        }


        // called perdiodically, depending on return from here
        public float chooseExpression() {
            var emotionDecider = RandomTable<RandomTable<ExpressionMorph>>.create();

            if(arousal>0)
                emotionDecider.add(getExcitedMorphs(arousal), arousal);
            if(scaredRelaxed<0)
                emotionDecider.add(getScaredMorphs(-scaredRelaxed), -scaredRelaxed); // scared
            // if(scaredRelaxed>0)
            //     emotionDecider.add(Expression.getRelaxed(this), scaredRelaxed); // relaxed 
            if(sadHappy<0)
                emotionDecider.add(getSadMorphs(-sadHappy), -sadHappy); // sad
            if(sadHappy>0)
                emotionDecider.add(getHappyMorphs(sadHappy), sadHappy); // happy

            var duration = getScaredRelaxedInterval();

            if(emotionDecider.entries.Count()>0) {
                try {
                    var selected = emotionDecider.getRandom().getRandom();

                    if(selected != null) {
                        Log.d($"{person.name} expression {selected.getName()} scheduled dur={duration}");
                        selected.fitInto(duration);
                        smartHeadChannel.run(selected);
                        //actingChannel.run(selected);
                    }
                } catch (Exception ex) {
                    Log.d($"Błąd choosera emotionDecider: {ex}");
                }
            }  

            return duration;
            // TODO - relaxed max = śpi

        }

        // called each frame
        public void processTouch(float deltaT) {
    //                                             <-smutny --- wesoły-> bazowa mina, kiedy nic nie jest wybrana
    // rozgląda się, szuka pomocy               <-przerażony --- odprężony-> przymyka oczy
    // unika kontaktu wzrokowego, spuszcza wzrok <-nieśmiały --- śmiały-> dłużej patrzy w oczy
    // patrzy w nic                             <-znudzony --- zaciekawiony -> skanuje wzrokiem
    // miny                                      <-ból --- przyjemność -> miny - RÓŻNICZKA!

    // przyjemnośc lub ból (zależnie od charakteru) zwiększa podniecenie
            float painPleasure = 0;

            // if(lastITouched == null) {

            // }
            // else if(isMale()) {
            //     // male gives touch
            // }
            // else {
            //     // female gives touch
            // }

            if(lastHit == null) {

            }
            else if(lastHit.hitType == EventType.HIT) {
                //spanked
                painPleasure = -lastHit.magnitude;
                var power = lastHit.magnitude / 2f;
                power = Mathf.Clamp(power, 0, 1);
                smartHeadChannel.preempt(getSpankedMorphs(power).getRandom());
                //recvTouchArousalDt = 
            }
            else if(lastHit.hitType == EventType.CARESS || lastHit.hitType == 10) {
                // painPleasure - ustawiamy na ileś, zależnie od miejsca dotyku

                if(lastHit.victimBodyPart.Contains("chest") || lastHit.victimBodyPart.Contains("pectoral")) {
                    painPleasure = 2f;
                    smartHeadChannel.maybe(getSmilesMorphs(1f).getRandom());
                    // Log.d($"{person.name} Chest touched");
                    if(isMale())
                        recvTouchArousalDt = 1/20f;
                    else
                        recvTouchArousalDt = 1/10f;
                }
                else if(lastHit.victimBodyPart.Contains("glute")) {
                    painPleasure = 2f;
                    smartHeadChannel.maybe(getSmilesMorphs(1f).getRandom());
                    // Log.d($"{person.name} Glute touched");
                    if(isMale())
                        recvTouchArousalDt = 1/20f;
                    else
                        recvTouchArousalDt = 1/10f;
                }
                else if(lastHit.victimBodyPart.Contains("abdomen")) {
                    painPleasure = 1f;
                    smartHeadChannel.maybe(getSmilesMorphs(0.8f).getRandom());
                    //Log.d($"{person.name} Abdomen touched");
                    if(isMale())
                        recvTouchArousalDt = 1/30f;
                    else
                        recvTouchArousalDt = 1/20f;
                }
                else if(lastHit.victimBodyPart.Contains("thigh")) {
                    painPleasure = 3f;
                    smartHeadChannel.maybe(getSmilesMorphs(1f).getRandom());
                    //Log.d($"{person.name} Thigh touched");
                    if(isMale())
                        recvTouchArousalDt = 1/20f;
                    else
                        recvTouchArousalDt = 1/10f;
                }
                else if(lastHit.victimBodyPart.Contains("nipple") || lastHit.victimBodyPart.Contains("areola")) {
                    painPleasure = 5f;
                    smartHeadChannel.maybe(getSmilesMorphs(1f).getRandom());
                    //Log.d($"{person.name} Nipple touched");
                    if(isMale())
                        recvTouchArousalDt = 1/10f;
                    else
                        recvTouchArousalDt = 1/2f;
                }
                else if(lastHit.victimBodyPart.Contains("pelvis")) {
                    //Log.d($"{person.name} Pelvis touched");
                    painPleasure = 4f;
                    smartHeadChannel.maybe(getSmilesMorphs(1f).getRandom());
                }
                else if(lastHit.victimBodyPart.Contains("head") || lastHit.victimBodyPart.Contains("neck")) {
                    //Log.d($"{person.name} Head/neck touched");
                    painPleasure = 1f;
                    smartHeadChannel.maybe(getHeadTouchMorphs(1f).getRandom());
                }
                else if(lastHit.victimBodyPart.Contains("lip") || lastHit.victimBodyPart.Contains("jaw")) {
                    //Log.d($"{person.name} Lips touched");
                    if(isMale())
                        recvTouchArousalDt = 1/10f;
                    else
                        recvTouchArousalDt = 1/5f;
                    painPleasure = 1f;
                    smartHeadChannel.maybe(getLipTouchMorphs(1f).getRandom());
                }
                else if(lastHit.victimBodyPart.Contains("labia")) {
                    //Log.d($"{person.name} Labia touched");
                    recvTouchArousalDt = 1/2f;
                    painPleasure = 5f;
                    smartHeadChannel.maybe(getGenitalTouchMorphs(1f).getRandom());
                }
                else if(lastHit.victimBodyPart.Contains("gen3")) {
                    //Log.d($"{person.name} gen3 touched");
                    recvTouchArousalDt = 1/2f;
                    painPleasure = 5f;
                    smartHeadChannel.maybe(getGenitalTouchMorphs(1f).getRandom());
                }
                else {
                    //Log.d($"{person.name} Somethig else touched:{lastHit.victimBodyPart}");
                    painPleasure = 0.5f;
                    recvTouchArousalDt = 1/40f;
                }
            }

            if(painPleasure == 0) {
                // nothing happening
                scaredRelaxed+=(0.005f * deltaT);
            }
            else if(painPleasure > 0) {
                // nice caress
                sadHappy+=(painPleasure*deltaT);
                //Log.d($"{person.name} arousal={arousal} painPleasure={painPleasure}, delta={deltaT}");
            }
            else {
                // something unpleasant
                if(sadHappy>0)
                    sadHappy = painPleasure*deltaT;
                else
                    sadHappy+=painPleasure*deltaT;

                scaredRelaxed = -1f;
            }

            sadHappy = Mathf.Clamp(sadHappy, -1, 1);
            scaredRelaxed = Mathf.Clamp(scaredRelaxed, -1, 1);

            lastHit = null;
            lastITouched = null;
        }    
    }
}