using System;

namespace Amaimon {
    class SchedulerJob {
        float runAfter = 0;
        Action<Scene> job = null;
        public bool isFinished = false;
    
        public SchedulerJob(float when, Action<Scene> what) {
            runAfter = when;
            job = what;
        }

        public void launchIfRequired(Scene s) {
            if(s.elapsed>=runAfter && !isFinished) {
                job(s);
                isFinished = true;
            }
        }
    }
}