namespace Amaimon {
    public class EmbodyPlugin : APlugin {
    public EmbodyPlugin(AActor actor) : base(actor, "Embody") { }
    override public void init() {
        ActivateOnLoad = new BoolProperty(this,"ActivateOnLoad");
        ReturnToSpawnPoint = new StringChooserProperty(this,"ReturnToSpawnPoint");
        Presets = new StringChooserProperty(this,"Presets");
        Active = new BoolProperty(this,"Active");
        // ProfilePathUrl = new Url(this,"ProfilePathUrl");
        LoadProfileWithPath = new ActionProperty(this,"LoadProfileWithPath");
        LaunchWizard = new ActionProperty(this,"LaunchWizard");
        ToggleActive = new ActionProperty(this,"ToggleActive");
        ReinitializeIfActive = new ActionProperty(this,"ReinitializeIfActive");
        ActivatePossession = new ActionProperty(this,"Activate_Possession");
        ActivateLeapMotion = new ActionProperty(this,"Activate_LeapMotion");
        ActivatePassenger = new ActionProperty(this,"Activate_Passenger");
    }
	
    private BoolProperty ActivateOnLoad;

	public void setActivateOnLoad(bool a) {
		ActivateOnLoad.set(a);
	}
	
	public bool getActivateOnLoad() {
		return ActivateOnLoad.get();
	}

	
    private StringChooserProperty ReturnToSpawnPoint;

	public void setReturnToSpawnPoint(string a) {
		ReturnToSpawnPoint.set(a);
	}
	
	public string getReturnToSpawnPoint() {
		return ReturnToSpawnPoint.get();
	}

	
    private StringChooserProperty Presets;

	public void setPresets(string a) {
		Presets.set(a);
	}
	
	public string getPresets() {
		return Presets.get();
	}

	
    private BoolProperty Active;

	public void setActive(bool a) {
		Active.set(a);
	}
	
	public bool getActive() {
		return Active.get();
	}

	
    // private Url ProfilePathUrl;

	// public void setProfilePathUrl(Url a) {
	// 	ProfilePathUrl.set(a);
	// }
	
	// public Url getProfilePathUrl() {
	// 	return ProfilePathUrl.get();
	// }

	
    public ActionProperty LoadProfileWithPath;

	
    public ActionProperty LaunchWizard;

	
    public ActionProperty ToggleActive;

	
    public ActionProperty ReinitializeIfActive;

	
    public ActionProperty ActivatePossession;

	
    public ActionProperty ActivateLeapMotion;

	
    public ActionProperty ActivatePassenger;

}

}