namespace Amaimon {
    public class HandAnimator : APlugin {
    public HandAnimator(AActor actor) : base(actor, "MVRPlugin.Template") { }
    override public void init() {
        DynamicallyAdjustHandMorphs = new BoolProperty(this,"Dynamically Adjust Hand Morphs");
        flattenonanysurfacebuggy = new BoolProperty(this,"flatten on any surface (buggy)");
        Showstatsonmessagelog = new BoolProperty(this,"Show stats on message log");
        StaticPoseModifier = new FloatProperty(this,"Static Pose Modifier");
        GraspMorphModifier = new FloatProperty(this,"Grasp Morph Modifier");
        StraightenMorphModifier = new FloatProperty(this,"Straighten Morph Modifier");
        ChopMorphModifier = new FloatProperty(this,"Chop Morph Modifier");
        ThumbsMorphsModifier = new FloatProperty(this,"Thumbs Morphs Modifier");
        ThumbsPositionOffset = new FloatProperty(this,"Thumbs Position Offset");
        MotionSpeedScale = new FloatProperty(this,"Motion Speed Scale");
        DistanceScale = new FloatProperty(this,"Distance Scale");
        AnimationSpeed = new FloatProperty(this,"Animation Speed");
        Relaxedfingercurl = new FloatProperty(this,"Relaxed finger curl");
        GroundLevel = new FloatProperty(this,"Ground Level");
        GroundClearance = new FloatProperty(this,"Ground Clearance");
        WalkAdjustToes = new BoolProperty(this,"Walk:Adjust Toes");
        WalkFootAngleOffset = new FloatProperty(this,"Walk:Foot Angle Offset");
        WalkToeMaxUpAngle = new FloatProperty(this,"Walk:Toe Max Up Angle");
        TargetSelector = new StringChooserProperty(this,"Target Selector");
    }
	
    private BoolProperty DynamicallyAdjustHandMorphs;

	public void setDynamicallyAdjustHandMorphs(bool a) {
		DynamicallyAdjustHandMorphs.set(a);
	}
	
	public bool getDynamicallyAdjustHandMorphs() {
		return DynamicallyAdjustHandMorphs.get();
	}

	
    private BoolProperty flattenonanysurfacebuggy;

	public void setflattenonanysurfacebuggy(bool a) {
		flattenonanysurfacebuggy.set(a);
	}
	
	public bool getflattenonanysurfacebuggy() {
		return flattenonanysurfacebuggy.get();
	}

	
    private BoolProperty Showstatsonmessagelog;

	public void setShowstatsonmessagelog(bool a) {
		Showstatsonmessagelog.set(a);
	}
	
	public bool getShowstatsonmessagelog() {
		return Showstatsonmessagelog.get();
	}

	
    private FloatProperty StaticPoseModifier;

	public void setStaticPoseModifier(float a) {
		StaticPoseModifier.set(a);
	}
	
	public float getStaticPoseModifier() {
		return StaticPoseModifier.get();
	}

	
    private FloatProperty GraspMorphModifier;

	public void setGraspMorphModifier(float a) {
		GraspMorphModifier.set(a);
	}
	
	public float getGraspMorphModifier() {
		return GraspMorphModifier.get();
	}

	
    private FloatProperty StraightenMorphModifier;

	public void setStraightenMorphModifier(float a) {
		StraightenMorphModifier.set(a);
	}
	
	public float getStraightenMorphModifier() {
		return StraightenMorphModifier.get();
	}

	
    private FloatProperty ChopMorphModifier;

	public void setChopMorphModifier(float a) {
		ChopMorphModifier.set(a);
	}
	
	public float getChopMorphModifier() {
		return ChopMorphModifier.get();
	}

	
    private FloatProperty ThumbsMorphsModifier;

	public void setThumbsMorphsModifier(float a) {
		ThumbsMorphsModifier.set(a);
	}
	
	public float getThumbsMorphsModifier() {
		return ThumbsMorphsModifier.get();
	}

	
    private FloatProperty ThumbsPositionOffset;

	public void setThumbsPositionOffset(float a) {
		ThumbsPositionOffset.set(a);
	}
	
	public float getThumbsPositionOffset() {
		return ThumbsPositionOffset.get();
	}

	
    private FloatProperty MotionSpeedScale;

	public void setMotionSpeedScale(float a) {
		MotionSpeedScale.set(a);
	}
	
	public float getMotionSpeedScale() {
		return MotionSpeedScale.get();
	}

	
    private FloatProperty DistanceScale;

	public void setDistanceScale(float a) {
		DistanceScale.set(a);
	}
	
	public float getDistanceScale() {
		return DistanceScale.get();
	}

	
    private FloatProperty AnimationSpeed;

	public void setAnimationSpeed(float a) {
		AnimationSpeed.set(a);
	}
	
	public float getAnimationSpeed() {
		return AnimationSpeed.get();
	}

	
    private FloatProperty Relaxedfingercurl;

	public void setRelaxedfingercurl(float a) {
		Relaxedfingercurl.set(a);
	}
	
	public float getRelaxedfingercurl() {
		return Relaxedfingercurl.get();
	}

	
    private FloatProperty GroundLevel;

	public void setGroundLevel(float a) {
		GroundLevel.set(a);
	}
	
	public float getGroundLevel() {
		return GroundLevel.get();
	}

	
    private FloatProperty GroundClearance;

	public void setGroundClearance(float a) {
		GroundClearance.set(a);
	}
	
	public float getGroundClearance() {
		return GroundClearance.get();
	}

	
    private BoolProperty WalkAdjustToes;

	public void setWalkAdjustToes(bool a) {
		WalkAdjustToes.set(a);
	}
	
	public bool getWalkAdjustToes() {
		return WalkAdjustToes.get();
	}

	
    private FloatProperty WalkFootAngleOffset;

	public void setWalkFootAngleOffset(float a) {
		WalkFootAngleOffset.set(a);
	}
	
	public float getWalkFootAngleOffset() {
		return WalkFootAngleOffset.get();
	}

	
    private FloatProperty WalkToeMaxUpAngle;

	public void setWalkToeMaxUpAngle(float a) {
		WalkToeMaxUpAngle.set(a);
	}
	
	public float getWalkToeMaxUpAngle() {
		return WalkToeMaxUpAngle.get();
	}

	
    private StringChooserProperty TargetSelector;

	public void setTargetSelector(string a) {
		TargetSelector.set(a);
	}
	
	public string getTargetSelector() {
		return TargetSelector.get();
	}

}
}